# -*- coding: utf-8 -*-

"""
shellev

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from shellev.api_helper import APIHelper
import shellev.exceptions.api_exception
from shellev.models.ratelimit_err_msg import RatelimitErrMsg


class TooManyRequestsException(shellev.exceptions.api_exception.APIException):
    def __init__(self, reason, response):
        """Constructor for the TooManyRequestsException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(TooManyRequestsException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.request_id = dictionary.get("requestId") if dictionary.get("requestId") else None
        self.status = dictionary.get("status") if dictionary.get("status") else None
        self.errors = None
        if dictionary.get('errors') is not None:
            self.errors = [RatelimitErrMsg.from_dictionary(x) for x in dictionary.get('errors')]
        else:
            self.errors = None
